package digital.laboratory.platform.inspetion.api.entity;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class TargetObject {
    /**
     * ID
     */
    @ApiModelProperty(value = "Id")
    private String id;


    /**
     * 英文名
     */
    @ApiModelProperty(value = "英文名")
    private String englishName;

    /**
     * 毒品类型
     */
    @ApiModelProperty(value = "毒品类型")
    private String drugType;

    /**
     * 发布时间
     */
    @ApiModelProperty(value = "发布时间")
    private String publishTime;

    /**
     * 实行时间
     */
    @ApiModelProperty(value = "实行时间")
    private String implementTime;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String comments;

    @ApiModelProperty(value = "code")
    private String code;

    /**
     * 毒品名称
     */
    @ApiModelProperty(value = "毒品名称")
    private String name;

    /**
     * 别名
     */
    @ApiModelProperty(value = "别名")
    private String alias;

    /**
     * CAS号
     */
    @ApiModelProperty(value = "CAS号")
    private String casCode;

    /**
     * 来源
     */
    @ApiModelProperty(value = "来源")

    private String source;


}
