package digital.laboratory.platform.inspection.mapper;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import digital.laboratory.platform.inspetion.api.entity.SampleInfo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/*
 *@title EntrustInfoMapper
 *@description
 *@author xy
 *@version 1.0
 *@create 2023/12/7 15:31
 */
@Mapper
public interface SampleInfoMapper extends BaseMapper<SampleInfo> {

    List<SampleInfo> getSampleInfoList(@Param(value = "businessId") String businessId, @Param(value = "testUser") String testUser);
    IPage<SampleInfo> getFullSampleInfoList(@Param("page") Page page, @Param(Constants.WRAPPER)LambdaQueryWrapper queryWrapper);

//    List<SampleInfo> getSampleInfoByAcceptNo(@Param(value = "acceptNo") String acceptNo, @Param(value = "idList") List<String> idList);
}
