package digital.laboratory.platform.inspection.dto;

import digital.laboratory.platform.sewage.vo.SewageJobIdentificationMaterialVO;
import lombok.Data;

@Data
@SuppressWarnings("all")
public class SewageDataDto extends SewageJobIdentificationMaterialVO {
    private Double cotinineConcentration = 0.0;//可替宁（ng/L）
    private Double codeineConcentration = 0.0;//可待因（ng/L）
    private Double mdaConcentration = 0.0;//MDA（ng/L）
    private Double mdmaConcentration = 0.0;//MDMA（ng/L）
    private Double cocaineConcentration = 0.0;//可卡因（ng/L）
    private Double benzoylecgonineConcentration = 0.0;//苯甲酰爱康宁（ng/L）
    private Double morphineConcentration = 0.0;//吗啡（ng/L）
    private Double acetylmorphineConcentration = 0.0;//O6-单乙酰吗啡（ng/L）
    private Double methamphetamineConcentration = 0.0;//甲基苯丙胺（ng/L）
    private Double amphetamineConcentration = 0.0;//苯丙胺（ng/L）
    private Double ketamineConcentration = 0.0;//氯胺酮（ng/L）
    private Double norketamineConcentration = 0.0;//去甲氯胺酮（ng/L）
    private Double thcConcentration = 0.0;//四氢大麻酸（ng/L）
    private Double fenConcentration = 0.0;//芬太尼（ng/L）
    private Double etomidateConcentration = 0.0;//依托咪酯（ng/L）
    private Double dailySmokingPerCapita;//人均日吸烟
    private Double cotinineExcretion;//可替宁排泄量（mg/千人天）
    private Double estimatedPopulation;//测算人口（千人）
    private Double morphineLoad;//吗啡负荷量
    private Double codeineLoad;//可待因负荷量
    private Double codeineIsConvertedToMorphineLoad;//可待因转化为吗啡负荷量
    private Double medicalMorphineLoad;//医用吗啡负荷量
    private Double MA_AM;
    private Double K_NK;
    private Double pccHeroin;//人均消耗量Heroin
    private Double pccMa;//人均消耗量MA

    private Double pccK;//人均消耗量K

    private Double pccMdma;//人均消耗量MDMA
    private Double pccCoc;//人均消耗量COC
    private Double pccThc;//人均消耗量THC
    private Double pccFen;//人均消耗量Fen

    private Double tcHeroin;//总消耗量Heroin
    private Double tcMa;//总消耗量MA
    private Double tcK;//总消耗量K
    private Double tcMdma;//总消耗量MDMA
    private Double tcCoc;//总消耗量COC
    private Double tcThc;//总消耗量THC
    private Double tcFen;//总消耗了Fen

}
