package digital.laboratory.platform.inspection.service;

import com.baomidou.mybatisplus.extension.service.IService;
import digital.laboratory.platform.common.core.util.R;
import org.apache.poi.ss.formula.functions.T;

import java.util.List;

/**
 * @author xy
 * @version 1.0
 * @title IdentifyBookDataService
 * @description
 * @create 2024/3/13 11:08
 */

public interface IdentifyBookDataService  {
    /**
     * 获取鉴定文书需要的数据
     * @param businessId
     * @return
     */
    R getIdentifyBookDataByBusinessId(String businessId);

    /**
     * 获取完成实验的数据
     * @return
     */
    R getTestFinishBusinessData(List<String> synedIdList);
}
