package digital.laboratory.platform.inspection.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.models.auth.In;
import lombok.Data;
import springfox.documentation.service.ApiListing;

@Data
@ApiModel(value = "TestRecordSolutionVO", description = "上机步骤中回显检材物列表的VO")
public class TestRecordSolutionVO {

    @ApiModelProperty("样本溶液id或者标准溶液id")
    private String id;

    @ApiModelProperty("溶液编号")
    private String number;

    @ApiModelProperty("溶液类型名称")
    private String typeName;

    @ApiModelProperty("进样次数")
    private Integer injectorCount = 1;

    @ApiModelProperty("架号")
    private String frameNumber;

    @ApiModelProperty("检验ID")
    private String testId;

    @ApiModelProperty("进样盘号位置")
    private String injectorLocation;
}
